<?php

$color_default = [
    [
        'key'       => 'stbl-black',
        'name'      => __( '黒', 'streetist-blocks' ),
        'default'   => '#111',
    ],
    [
        'key'       => 'stbl-white',
        'name'      => __( '白', 'streetist-blocks' ),
        'default'   => '#fff',
    ],
    [
        'key'       => 'stbl-dark-gray',
        'name'      => __( '濃いグレー', 'streetist-blocks' ),
        'default'   => '#6b6b6b'
    ],
    [
        'key'       => 'stbl-green',
        'name'      => __( 'グリーン', 'streetist-blocks' ),
        'default'   => '#14820e',
    ],
    [
        'key'       => 'stbl-turquoise',
        'name'      => __( 'ターコイズ', 'streetist-blocks' ),
        'default'   => '#36b8bc',
    ],
    [
        'key'       => 'stbl-blue',
        'name'      => __( 'ブルー', 'streetist-blocks' ),
        'default'   => '#1f62c1',
    ],
    [
        'key'       => 'stbl-purple',
        'name'      => __( 'パープル', 'streetist-blocks' ),
        'default'   => '#b438c1',
    ],
    [
        'key'       => 'stbl-red',
        'name'      => __( 'レッド', 'streetist-blocks' ),
        'default'   => '#b41818',
    ],
    [
        'key'       => 'stbl-pink',
        'name'      => __( 'ピンク', 'streetist-blocks' ),
        'default'   => '#d15353',
    ],
    [
        'key'       => 'stbl-orange',
        'name'      => __( 'オレンジ', 'streetist-blocks' ),
        'default'   => '#e87e0d',
    ],
    [
        'key'       => 'stbl-yellow',
        'name'      => __( 'イエロー', 'streetist-blocks' ),
        'default'   => '#f0f00e',
    ],
    [
        'key'       => 'stbl-light-gray',
        'name'      => __( 'ライトグレー', 'streetist-blocks' ),
        'default'   => '#999999',
    ],
    [
        'key'       => 'stbl-light-green',
        'name'      => __( 'ライトグリーン', 'streetist-blocks' ),
        'default'   => '#86e5ad',
    ],
    [
        'key'       => 'stbl-light-turquoise',
        'name'      => __( 'ライトターコイズ', 'streetist-blocks' ),
        'default'   => '#82d4d7',
    ],
    [
        'key'       => 'stbl-light-blue',
        'name'      => __( 'ライトブルー', 'streetist-blocks' ),
        'default'   => '#90c4ed',
    ],
    [
        'key'       => 'stbl-light-purple',
        'name'      => __( 'ライトパープル', 'streetist-blocks' ),
        'default'   => '#e188eb',
    ],
    [
        'key'       => 'stbl-light-pink',
        'name'      => __( 'ライトピンク', 'streetist-blocks' ),
        'default'   => '#e79090',
    ],
    [
        'key'       => 'stbl-light-orange',
        'name'      => __( 'ライトオレンジ', 'streetist-blocks' ),
        'default'   => '#eeaf6c',
    ],
    [
        'key'       => 'stbl-light-yellow',
        'name'      => __( 'ライトイエロー', 'streetist-blocks' ),
        'default'   => '#f2f274',
    ],
    [
        'key'       => 'stbl-pale-gray',
        'name'      => __( '淡いグレー', 'streetist-blocks' ),
        'default'   => '#f5f5f5',
    ],
    [
        'key'       => 'stbl-pale-turquoise',
        'name'      => __( '淡いターコイズ', 'streetist-blocks' ),
        'default'   => '#cbeff0',
    ],
    [
        'key'       => 'stbl-pale-blue',
        'name'      => __( '淡いブルー', 'streetist-blocks' ),
        'default'   => '#e8f8ff',
    ],
    [
        'key'       => 'stbl-pale-purple',
        'name'      => __( '淡いパープル', 'streetist-blocks' ),
        'default'   => '#f1d6f4',
    ],
    [
        'key'       => 'stbl-pale-pink',
        'name'      => __( '淡いピンク', 'streetist-blocks' ),
        'default'   => '#ffeded',
    ],
    [
        'key'       => 'stbl-pale-orange',
        'name'      => __( '淡いオレンジ', 'streetist-blocks' ),
        'default'   => '#fff5e2',
    ],
    [
        'key'       => 'stbl-pale-yellow',
        'name'      => __( '淡いイエロー', 'streetist-blocks' ),
        'default'   => '#fffcdc',
    ],
    [
        'key'       => 'stbl-custom-1',
        'name'      => __( 'カスタム 1', 'streetist-blocks' ),
        'default'   => '#eee',
    ],
    [
        'key'       => 'stbl-custom-2',
        'name'      => __( 'カスタム 2', 'streetist-blocks' ),
        'default'   => '#ddd',
    ],
    [
        'key'       => 'stbl-custom-3',
        'name'      => __( 'カスタム 3', 'streetist-blocks' ),
        'default'   => '#ccc',
    ],
];
define('stbl_DEFAULT_COLORS', $color_default);

function stbl_color_palette() {
    $palette = array();

    $color_settings = stbl_DEFAULT_COLORS;

    foreach ($color_settings as $color) {
        array_push($palette, [
            'name'  => $color['name'],
            'slug'  => $color['key'],
            'color' => get_option('stbl_block_color_' . $color['key'], $color['default']),
        ]);
    }

    add_theme_support('editor-color-palette', $palette);
}

add_action('init', 'stbl_color_palette', 11);

if (!function_exists('stbl_get_inline_style')) {
    function stbl_get_inline_style() {

        $color_settings = stbl_DEFAULT_COLORS;
        
        ob_start();
foreach ($color_settings as $color) {
    $value = get_option('stbl_block_color_' . $color["key"], $color["default"]);
    echo '.has-' . $color['key'] . '-color {color: ' . $value . ';}';
    echo '.has-' . $color['key'] . '-background-color{background-color: ' . $value . ';}';
}
        $style = ob_get_contents();
        ob_end_clean();
        
        return $style;
    }
}


if (!function_exists('stbl_output_inline_style')) {
    function stbl_output_inline_style() {
        $style = stbl_get_inline_style();
        wp_add_inline_style('style-streetist-blocks', $style);
    }
    add_action('wp_enqueue_scripts', 'stbl_output_inline_style');
}

if (!function_exists('stbl_output_inline_editor_style')) {
    function stbl_output_inline_editor_style()
    {
        $style = stbl_get_inline_style();
        wp_add_inline_style('editor-style-streetist-blocks', $style);
    }
    add_action('enqueue_block_editor_assets', 'stbl_output_inline_editor_style');
}

